<template>
  <div>
    <q-list>
      <div v-if="config.columns.length">
        <draggable
          :list="config.columns"
          handle=".column__drag-handle"
        >
          <q-item
            v-for="(column, index) in config.columns"
            :key="index"
          >
            <column
              :column="column"
              @remove="removeColumn(index)"
              @edit="editColumn(index)"
              :available-fields="availableFields"
            />
          </q-item>
        </draggable>
      </div>
      <div
        class="text-grey text-italic q-pa-sm"
        v-else
      >
        No added columns. Click button below to add one
      </div>
    </q-list>
    <q-btn
      icon="add"
      label="Add column"
      color="green"
      class="q-mt-md"
      @click="addColumn"
    />
    <column-editor
      :column="config.columns[editingColumnIndex]"
      @close="editingColumnIndex = null"
    />
  </div>
</template>

<script>
  import { defaultCollectionColumn } from '../../../../../../utilities/migrateConfig';
  import Column from './column';
  import ColumnEditor from './columnEditor';

  export default {
    name: 'collectionColumns',
    components: { ColumnEditor, Column },
    props: {
      config: {
        type: Object,
      },
      availableFields: {
        type: Array,
      },
    },
    data() {
      return {
        editingColumnIndex: null,
      };
    },
    methods: {
      removeColumn(index) {
        this.config.columns.splice(index, 1);
      },
      editColumn(index) {
        this.editingColumnIndex = index;
      },
      addColumn() {
        this.config.columns.push({ ...defaultCollectionColumn });
      },
    },
  };
</script>
